<template>
  <div>
    <div class="buttons-list">
      <button @click="subscribe" class="button button-success">{{ $t('fetchData.subscribe') }}</button>
      <button @click="unsibscribe" class="button button-danger">{{ $t('fetchData.unsubscribe') }}</button>
      <button @click="clear" class="button button-warning">{{ $t('fetchData.clear') }}</button>
    </div>

    <h3 class="transactions-sum"> {{ $t('fetchData.sum', { value: totalAmount }) }}</h3>

    <div class="box-content">
      <ui-kit-results-table
        :fields="tableFields"
        :entities="transactions"
      ></ui-kit-results-table>
    </div>
  </div>
</template>

<script lang="ts">
  import { Component, Vue } from 'nuxt-property-decorator';
  import {
    CLEAR_TRANSACTION,
    CONNECT_SOCKET,
    GET_TOTAL_AMOUNT,
    SUBSCRIBE_TRANSACTIONS,
    UNSUBSCRIBE_TRANSACTION
  } from '~/store/transactions';
  import UiKitResultsTable from "~/components/UiKitResultsTable.vue";
  import { SimpleTableHeaderItem } from "~/types/uiKit";

  @Component({
    components: {UiKitResultsTable}
  })
  export default class DragModals extends Vue {
    tableFields: SimpleTableHeaderItem[] = [
      { class: 'col-40', name: 'fetchData.from' },
      { class: 'col-40', name: 'fetchData.to' },
      { class: 'col-20', name: 'fetchData.amount' }
    ];

    fetch({ store }) {
      store.commit('setTitle', 'sidebar.fetchData');
    }

    beforeMount() {
      this.$store.dispatch(CONNECT_SOCKET)
    }

    get totalAmount() {
      return this.$store.getters[GET_TOTAL_AMOUNT];
    }

    get transactions() {
      return this.$store.state.transactions.items.map((transaction) => {
        const totalBefore = transaction.x.inputs.reduce((sum, input) => sum += input.prev_out.value, 0);
        const totalAfter = transaction.x.out.reduce((sum, out) => sum += out.value, 0);

        return {
          line: [
            transaction.x.inputs.map((input) => input.prev_out.addr).join(', '),
            transaction.x.out.map((out) => out.addr).join(', '),
            totalBefore - totalAfter
          ]
        }
      });
    }

    public subscribe() {
      this.$store.dispatch(SUBSCRIBE_TRANSACTIONS)
    }

    public unsibscribe() {
      this.$store.dispatch(UNSUBSCRIBE_TRANSACTION)
    }

    public clear() {
      this.$store.commit(CLEAR_TRANSACTION)
    }
  }
</script>
